// major.cc -- Test of simultaneous triggering with chords
//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Thu Feb 13 13:04:46 PST 1997
// Last Modified: Thu Feb 13 13:04:51 PST 1997
// Filename:      /user/c/craig/lang/c/drum/examples/pitchwheel.cc
// Syntax:        C++ (Gnu C++ compiler: /Local/Unix/bin/g++)
// $Smake:        g++ -O -o %b %f -I../include -L../lib %
//                -ldrum -lmidi -loptions && strip %b
//                Type "../bin/smake FILENAME" to compile this file.
//

#include "main.cc"

Note  xavier;                         // Baton 1 note 
Note  zeta;			      // Baton 2 note

/***************** Beginning of user functions ****************************/


/*---------------- Documentation functions -------------------------------*/

void description(void) {
   cout
   << "______________________________________________________________ \n"
   << "| Description:                                                |\n"
   << "|    This is a test of the Pitch Wheel command.               |\n"
   << "|                          -- Craig Stuart Sapp, 13 Mar 1996  |\n"
   << "---------------------------------------------------------------\n"
   ;
}


void programhelp(void) {
   cout

   << ">                                                              \n"
   << "> Baton 1:                                                     \n"
   << ">    x1t:                                                      \n"
   << ">    y1t:                                                      \n"
   << ">    w1t:                                                      \n"
   << "> Baton 2:                                                     \n"
   << ">    x2t:                                                      \n"
   << ">    y2t:                                                      \n"
   << ">    w2t:                                                      \n"
   << ">                                                              \n"
   << ">    p1p:                                                      \n"
   << ">    p2p:                                                      \n"
   << ">   +b14:                                                      \n"
   << ">   +b15:                                                      \n"
   << ">                                                              \n"
   ;
}

/*---------------- Initialization functions ------------------------------*/

void initialization(void) { 
   description(); 
   drum.setPollRate(20);		// poll rate of baton set to 20 ms
}

/*---------------- Main loop functions -----------------------------------*/

void mainloopalgorithms(void) { drum.checkPollAll(); }

/*---------------- Trigger response functions ----------------------------*/

void stick1trig(void) {
   cout << "Baton 1 triggered." << endl;
   xavier.play(0, baton.x1t, 127);
}

void stick2trig(void) {
   cout << "Baton 2 triggered." << endl;
   zeta.play(0, x1t, 127);
}

void b14plustrig(void) { cout << "B14+ triggered\n"; commandmode(); }
void b15plustrig(void) { cout << "B15+ triggered\n"; programhelp(); }

/*---------------- Poll response functions -------------------------------*/

void stick1pollresponse(void) {
   midi.pw(0, baton.x1p, baton.x1p)  
}
void stick2pollresponse(void) { }
void potspollresponse(void) { }

/*---------------- Actions to take just before leaving program -----------*/

void cleanup(void) { }

/***************** End of user functions **********************************/

