//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: 23 December 1997
// Last Modified: 23 December 1997
// Filename:      print.cpp
// Syntax:        Visual C++ 5.0; Radio Baton Improv
//  
// Description: Prints a message to the screen when a button, baton
//      or foot pedal is pressed.
//

#include "improv.h" 


/*----------------- beginning of improvization algorithms ---------------*/

int mainprint;      // to determine when to print in mainloopalgorithm

/*--------------------- maintenance algorithms --------------------------*/

void description(void) {
   cout << "print --\n";
   cout << "   This program prints a statement whenever a stick, button\n";
   cout << "   or footpedal is triggered.\n";
   cout << "\n   The b14+ button will toggle printing in the main loop\n";
   cout << endl;
} 

void initialization(void) { 
   cout << "In initialization function" << endl; 
   mainprint = 0;      // set to false, true is any other number (usu. 1).
}

void finishup(void) { 
   cout << "In cleanup function" << endl; 
}


/*-------------------- main loop algorithms -----------------------------*/

void mainloopalgorithms(void) { 
   if (mainprint) {
      cout << "In main loop algorithm" << endl;
   }
}


/*-------------------- triggered algorithms -----------------------------*/

void stick1trig(void) { 
   cout << "\nStick 1 triggered" << endl; 
}

void stick2trig(void) { 
   cout << "\nStick 2 triggered" << endl; 
}

void b14plustrig(void) { 
   cout << "\nb14+ button pushed" << endl; 
   mainprint = !mainprint;  // if mainprint is false then make true, or v.v.
   if (mainprint) {
      cout << "mainloopalgorithm printing is on" << endl;
   } else {
      cout << "mainloopalgorithm printing is off" << endl;
   }
}

void b15plustrig(void) { 
   cout << "\nb15+ button pushed" << endl; 
}

void b14minusuptrig(void) { 
   cout << "\nb14- pedal depressed" << endl; 
}

void b14minusdowntrig(void) { 
   cout << "\nb14- pedal released" << endl; 
}

void b15minusuptrig(void) { 
   cout << "\nb15- pedal depressed" << endl; 
}

void b15minusdowntrig(void) { 
   cout << "\nb15- pedal released" << endl; 
}

void keyboardchar(int key) { 
   cout << "A character was received by keyboardchar: " << key << endl;
}


/*------------------ end improvization algorithms -----------------------*/


/*
   some functions and variables provided by the support program

   program_change(channel, instrument); -------- sets the timbre for a channel
   control_change(channel, controller, value); - sends a continuous controller 
   note_on(channel, keynumber, keyvelocity); --- plays a MIDI note
   note_off(channel, keynumber); --------------- same as note_on with 0 vel.
   raw_send(channel, command, data1, data2); --- send some midi command
   long t_time; -------------------------------- current time in milliseconds
   short pt1, pt2, pt3, pt4; ------------------- current pot (dial) positions
   short xt1,yt1,zt1,xt2,yt2,zt2; -------------- current stick positions
   short wh1, wh2; ----------------------------- whack strength of a trigger
   short xw1, yw1, xw2, yw2; ------------------- x and y positions at trigger
   short hit1, set1, hit2, set2; --------------- hit and set levels of sticks
   short whack1,whack2; ------------------------ registers set by stick triggers
   long  trigtime1, trigtime2; ----------------- times of stick triggers
*/


